<?php

/**
/**
 * Payment Modul fur girosolution.de.
 *
 * @version   4.3.12
 * @author    OCS
 * @copyright 2011-2016 GiroSolution AG
 * @link      http://www.girosolution.de
 * @link      http://www.gambio.de
 * @license   http://opensource.org/licenses/gpl-2.0.php GNU Public License
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */
define("__GIROCONNECT_PLUGIN_VERSION__", "4.3.12");
if (file_exists(DIR_FS_CATALOG . 'includes/classes/giroconnect/library/GiroCheckout_SDK/GiroCheckout_SDK.php')) {
  require_once DIR_FS_CATALOG . 'includes/classes/giroconnect/library/GiroCheckout_SDK/GiroCheckout_SDK.php';
} else {
  require_once '../includes/classes/giroconnect/library/GiroCheckout_SDK/GiroCheckout_SDK.php';
}
define('COMPARE_SHOP_VERSION', 'v4.1');

GiroCheckout_SDK_Config::getInstance()->setConfig('DEBUG_LOG_PATH', DIR_FS_CATALOG . 'logfiles/girocheckout');

/**
 * Main class for girocheckout plugin.
 *
 * @author GiroSolution AG
 * @package GiroCheckout
 * @copyright Copyright (c) 2015, GiroSolution AG
 */
class giroconnect_main {

  var $code, $title, $description, $transaction_id, $language, $enabled, $tmpStatus, $useExternalFormService;
  var $Purpose = "";

  const PAYMENT_NAME_GIROPAY = 'gc_giropay';
  const PAYMENT_NAME_DIRECTDEBIT = 'gc_directdebit';
  const PAYMENT_NAME_CREDITCARD = 'gc_creditcard';
  const PAYMENT_NAME_IDEAL = 'gc_ideal';
  const PAYMENT_NAME_EPS = 'gc_eps';
  const PAYMENT_NAME_PAYDIREKT = 'gc_paydirekt';
  const PAYMENT_NAME_SOFORTUW = 'gc_sofortuw';

  /**
   * Constructor method.
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return void
   */
  public function __construct() {
    $this->transaction_id = '';
  }

// end giroconnect_main()

  /**
   * Set the language code
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return void
   */
  function _setLang() {
    if (substr($_SESSION['language_code'], 0, 2) == 'de') {
      $this->language = 'de';
    } else {
      $this->language = 'en';
    }
  }

// end _setLang()

  /**
   * Set the payment method code
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return void
   */
  function _setCode($code = 'gc_giropay') {
    $this->code = $code;
    $this->module = $code;
  }

// end _setCode()

  /**
   * Check if constant is defined.
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return string
   */
  function constant($name) {
    return (defined($name)) ? constant($name) : NULL;
  }

  // end constant()

  /**
   * Javascript validation
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return boolean
   */
  function javascript_validation() {

    return false;
  }

// end javascript_validation()

  /**
   * Update the module status dynamically
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return void
   */
  function update_status() {
    global $order;

    $merchantId = trim(giroconnect_main::constant('MODULE_PAYMENT_' . strtoupper($this->code) . '_MERCHANTID'));
    $projectId = trim(giroconnect_main::constant('MODULE_PAYMENT_' . strtoupper($this->code) . '_PROJECTID'));
    $password = trim(giroconnect_main::constant('MODULE_PAYMENT_' . strtoupper($this->code) . '_PASSWORD'));

    //Checks if the currency is EURO
    $currency = $_SESSION['currency'];

    if (($this->enabled == true) && ((int) giroconnect_main::constant('MODULE_PAYMENT_' . strtoupper($this->code) . '_ZONE') > 0)) {
      $check_flag = false;
      $check_query = xtc_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . xtc_db_input(giroconnect_main::constant('MODULE_PAYMENT_' . strtoupper($this->code) . '_ZONE')) .
        "' and zone_country_id = '" . xtc_db_input($order->billing['country']['id']) . "' order by zone_id");
      while ($check = xtc_db_fetch_array($check_query)) {
        if ($check['zone_id'] < 1) {
          $check_flag = true;
          break;
        } elseif ($check['zone_id'] == $order->billing['zone_id']) {
          $check_flag = true;
          break;
        }
      }

      if ($check_flag == false) {
        $this->enabled = false;
      }
    } else if (($this->enabled == true) && (empty($merchantId) || empty($projectId) || empty($password))) {
      $this->enabled = false;
    } else if ($this->code != "gc_creditcard" && $currency != "EUR") {
      $this->enabled = false;
    }
  }

// end update_status()

  /**
   * Displays the payment description in checkout confirmation page
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return void
   */
  function confirmation() {
    $strConfirmation = array('title' => $this->description_checkout);

    return $strConfirmation;
  }

// End confirmation()

  /**
   * Delete the order
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return void
   */
  function _deleteOrder($order_id) {
    $check_query = xtc_db_query('select orders_id from ' . TABLE_ORDERS_STATUS_HISTORY . ' where orders_id = "' . xtc_db_input((int) $order_id) . '" limit 1');
    if (xtc_db_num_rows($check_query) < 1) {
      xtc_db_query('delete from ' . TABLE_ORDERS . ' where orders_id = "' . xtc_db_input((int) $order_id) . '"');
      xtc_db_query('delete from ' . TABLE_ORDERS_TOTAL . ' where orders_id = "' . xtc_db_input((int) $order_id) . '"');
      xtc_db_query('delete from ' . TABLE_ORDERS_STATUS_HISTORY . ' where orders_id = "' . xtc_db_input((int) $order_id) . '"');
      xtc_db_query('delete from ' . TABLE_ORDERS_PRODUCTS . ' where orders_id = "' . xtc_db_input((int) $order_id) . '"');
      xtc_db_query('delete from ' . TABLE_ORDERS_PRODUCTS_ATTRIBUTES . ' where orders_id = "' . xtc_db_input((int) $order_id) . '"');
      xtc_db_query('delete from ' . TABLE_ORDERS_PRODUCTS_DOWNLOAD . ' where orders_id = "' . xtc_db_input((int) $order_id) . '"');
    }

    unset($_SESSION[$this->_gc_cartID]);
  }

// End _deleteOrder()

  /**
   * Functions to execute before process the payment
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return boolean
   */
  function before_process() {
    if (class_exists('CheckoutProcessProcess')) {
      unset($_SESSION['tmp_oID']);
      $this->tmpOrders = true;
      return true;
    }

    global $order;

    require_once DIR_WS_CLASSES . 'order_total.php';
    $order_total_modules = new order_total();
    $order_totals = $order_total_modules->process();

    # PropertiesControl Object
    $coo_properties = MainFactory::create_object('PropertiesControl');

    // BMC CC Mod Start
    if (strtolower(CC_ENC) == 'true') {
      $plain_data = $order->info['cc_number'];
      $order->info['cc_number'] = changedatain($plain_data, CC_KEYCHAIN);
    }

    // BMC CC Mod End
    if ($_SESSION['customers_status']['customers_status_ot_discount_flag'] == 1) {
      $discount = $_SESSION['customers_status']['customers_status_ot_discount'];
    } else {
      $discount = '0.00';
    }

    /* bof gm */
    if (($_POST['gm_log_ip'] == 'save' && gm_get_conf("GM_LOG_IP") == '1') || (gm_get_conf("GM_SHOW_IP") == '1' && gm_get_conf("GM_LOG_IP") == '1')) {
      if ($_SERVER["HTTP_X_FORWARDED_FOR"]) {
        $customers_ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
      } else {
        $customers_ip = $_SERVER["REMOTE_ADDR"];
      }
    }

    /* eof gm */
    if (isset($_POST['comments']) && empty($order->info['comments'])) {
      $order->info['comments'] = gm_prepare_string($_POST['comments'], true);
    } elseif (isset($_SESSION['comments']) && empty($order->info['comments'])) {
      $order->info['comments'] = $_SESSION['comments'];
    }

    if ($_SESSION['credit_covers'] != '1') {
      $sql_data_array = array(
        'customers_id' => $_SESSION['customer_id'],
        'customers_name' => $order->customer['firstname'] . ' ' . $order->customer['lastname'],
        'customers_firstname' => $order->customer['firstname'],
        'customers_lastname' => $order->customer['lastname'],
        'customers_cid' => $order->customer['csID'],
        'customers_vat_id' => $_SESSION['customer_vat_id'],
        'customers_company' => $order->customer['company'],
        'customers_status' => $_SESSION['customers_status']['customers_status_id'],
        'customers_status_name' => $_SESSION['customers_status']['customers_status_name'],
        'customers_status_image' => $_SESSION['customers_status']['customers_status_image'],
        'customers_status_discount' => $discount,
        'customers_street_address' => $order->customer['street_address'],
        'customers_suburb' => $order->customer['suburb'],
        'customers_city' => $order->customer['city'],
        'customers_postcode' => $order->customer['postcode'],
        'customers_state' => $order->customer['state'],
        'customers_country' => $order->customer['country']['title'],
        'customers_telephone' => $order->customer['telephone'],
        'customers_email_address' => $order->customer['email_address'],
        'customers_address_format_id' => $order->customer['format_id'],
        'delivery_name' => $order->delivery['firstname'] . ' ' . $order->delivery['lastname'],
        'delivery_firstname' => $order->delivery['firstname'],
        'delivery_lastname' => $order->delivery['lastname'],
        'delivery_company' => $order->delivery['company'],
        'delivery_street_address' => $order->delivery['street_address'],
        'delivery_suburb' => $order->delivery['suburb'],
        'delivery_city' => $order->delivery['city'],
        'delivery_postcode' => $order->delivery['postcode'],
        'delivery_state' => $order->delivery['state'],
        'delivery_country' => $order->delivery['country']['title'],
        'delivery_country_iso_code_2' => $order->delivery['country']['iso_code_2'],
        'delivery_address_format_id' => $order->delivery['format_id'],
        'billing_name' => $order->billing['firstname'] . ' ' . $order->billing['lastname'],
        'billing_firstname' => $order->billing['firstname'],
        'billing_lastname' => $order->billing['lastname'],
        'billing_company' => $order->billing['company'],
        'billing_street_address' => $order->billing['street_address'],
        'billing_suburb' => $order->billing['suburb'],
        'billing_city' => $order->billing['city'],
        'billing_postcode' => $order->billing['postcode'],
        'billing_state' => $order->billing['state'],
        'billing_country' => $order->billing['country']['title'],
        'billing_country_iso_code_2' => $order->billing['country']['iso_code_2'],
        'billing_address_format_id' => $order->billing['format_id'],
        'payment_method' => $order->info['payment_method'],
        'payment_class' => $order->info['payment_class'],
        'shipping_method' => $order->info['shipping_method'],
        'shipping_class' => $order->info['shipping_class'],
        'cc_type' => $order->info['cc_type'],
        'cc_owner' => $order->info['cc_owner'],
        'cc_number' => $order->info['cc_number'],
        'cc_expires' => $order->info['cc_expires'],
        'cc_start' => $order->info['cc_start'],
        'cc_cvv' => $order->info['cc_cvv'],
        'cc_issue' => $order->info['cc_issue'],
        'date_purchased' => 'now()',
        'orders_status' => $this->tmpStatus,
        'currency' => $order->info['currency'],
        'currency_value' => $order->info['currency_value'],
        'customers_ip' => $customers_ip,
        'language' => $_SESSION['language'],
        'comments' => $order->info['comments']
      );
    } else {
      // free gift , no paymentaddress
      $sql_data_array = array(
        'customers_id' => $_SESSION['customer_id'],
        'customers_name' => $order->customer['firstname'] . ' ' . $order->customer['lastname'],
        'customers_firstname' => $order->customer['firstname'],
        'customers_lastname' => $order->customer['lastname'],
        'customers_cid' => $order->customer['csID'],
        'customers_vat_id' => $_SESSION['customer_vat_id'],
        'customers_company' => $order->customer['company'],
        'customers_status' => $_SESSION['customers_status']['customers_status_id'],
        'customers_status_name' => $_SESSION['customers_status']['customers_status_name'],
        'customers_status_image' => $_SESSION['customers_status']['customers_status_image'],
        'customers_status_discount' => $discount,
        'customers_street_address' => $order->customer['street_address'],
        'customers_suburb' => $order->customer['suburb'],
        'customers_city' => $order->customer['city'],
        'customers_postcode' => $order->customer['postcode'],
        'customers_state' => $order->customer['state'],
        'customers_country' => $order->customer['country']['title'],
        'customers_telephone' => $order->customer['telephone'],
        'customers_email_address' => $order->customer['email_address'],
        'customers_address_format_id' => $order->customer['format_id'],
        'delivery_name' => $order->delivery['firstname'] . ' ' . $order->delivery['lastname'],
        'delivery_firstname' => $order->delivery['firstname'],
        'delivery_lastname' => $order->delivery['lastname'],
        'delivery_company' => $order->delivery['company'],
        'delivery_street_address' => $order->delivery['street_address'],
        'delivery_suburb' => $order->delivery['suburb'],
        'delivery_city' => $order->delivery['city'],
        'delivery_postcode' => $order->delivery['postcode'],
        'delivery_state' => $order->delivery['state'],
        'delivery_country' => $order->delivery['country']['title'],
        'delivery_country_iso_code_2' => $order->delivery['country']['iso_code_2'],
        'delivery_address_format_id' => $order->delivery['format_id'],
        'payment_method' => $order->info['payment_method'],
        'payment_class' => $order->info['payment_class'],
        'shipping_method' => $order->info['shipping_method'],
        'shipping_class' => $order->info['shipping_class'],
        'cc_type' => $order->info['cc_type'],
        'cc_owner' => $order->info['cc_owner'],
        'cc_number' => $order->info['cc_number'],
        'cc_expires' => $order->info['cc_expires'],
        'date_purchased' => 'now()',
        'orders_status' => $this->tmpStatus,
        'currency' => $order->info['currency'],
        'currency_value' => $order->info['currency_value'],
        'customers_ip' => $customers_ip,
        'comments' => $order->info['comments'],
        'language' => $_SESSION['language']
      );
    }

    xtc_db_perform(TABLE_ORDERS, $sql_data_array);
    $insert_id = xtc_db_insert_id();
    $_SESSION['tmp_oID'] = $insert_id;
    for ($i = 0, $n = sizeof($order_totals); $i < $n; $i++) {
      $sql_data_array = array(
        'orders_id' => $insert_id,
        'title' => $order_totals[$i]['title'],
        'text' => $order_totals[$i]['text'],
        'value' => $order_totals[$i]['value'],
        'class' => $order_totals[$i]['code'],
        'sort_order' => $order_totals[$i]['sort_order']
      );
      xtc_db_perform(TABLE_ORDERS_TOTAL, $sql_data_array);
    }

    //add order comment of customer to order history
    if (!empty($order->info['comments'])) {
      $customer_notification = '0';
      $sql_data_array = array(
        'orders_id' => $insert_id,
        'orders_status_id' => $this->tmpStatus,
        'date_added' => 'now()',
        'customer_notified' => $customer_notification,
        'comments' => $order->info['comments']
      );
      xtc_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
    }

    /* magnalister v1.0.1 */
    if (function_exists('magnaExecute')) {
      magnaExecute('magnaInsertOrderDetails', array('oID' => $insert_id), array('order_details.php'));
    }
    if (function_exists('magnaExecute')) {
      magnaExecute('magnaInventoryUpdate', array('action' => 'inventoryUpdateOrder'), array('inventoryUpdate.php'));
    }
    /* END magnalister */

    // initialized for the email confirmation
    $products_ordered = '';
    $products_ordered_html = '';
    $subtotal = 0;
    $total_tax = 0;

    // BOF GM_MOD products_shippingtime:
    require_once (DIR_FS_CATALOG . 'gm/inc/set_shipping_status.php');

    for ($i = 0, $n = sizeof($order->products); $i < $n; $i++) {
      // check if combis exists
      $t_combis_id = $coo_properties->extract_combis_id($order->products[$i]['id']);

      // Stock Update - Joao Correia
      if (STOCK_LIMITED == 'true') {
        if (DOWNLOAD_ENABLED == 'true') {
          // BOF GM_MOD:
          $stock_query_raw = "SELECT p.products_quantity, pad.products_attributes_filename
                                FROM " . TABLE_PRODUCTS . " p
                                LEFT JOIN " . TABLE_PRODUCTS_ATTRIBUTES . " pa
                                    ON p.products_id=pa.products_id
                                LEFT JOIN " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad
                                    ON pa.products_attributes_id=pad.products_attributes_id
                                WHERE p.products_id = '" . xtc_db_input(xtc_get_prid($order->products[$i]['id'])) . "'";
          // Will work with only one option for downloadable products
          // otherwise, we have to build the query dynamically with a loop
          $products_attributes = $order->products[$i]['attributes'];
          if (is_array($products_attributes)) {
            $stock_query_raw = "SELECT p.products_quantity, pad.products_attributes_filename
                                FROM " . TABLE_PRODUCTS . " p
                                LEFT JOIN " . TABLE_PRODUCTS_ATTRIBUTES . " pa
                                    ON (p.products_id=pa.products_id AND pa.options_id = '" . xtc_db_input((int) $products_attributes[0]['option_id']) .
              "' AND pa.options_values_id = '" . xtc_db_input((int) $products_attributes[0]['value_id']) . "')
                                LEFT JOIN " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad
                                    ON pa.products_attributes_id=pad.products_attributes_id
                                WHERE p.products_id = '" . xtc_db_input(xtc_get_prid($order->products[$i]['id'])) . "'";
          }
          $stock_query = xtc_db_query($stock_query_raw, "db_link", false);
        } else {
          $stock_query = xtc_db_query("select products_quantity from " . TABLE_PRODUCTS . " where products_id = '" . xtc_db_input(xtc_get_prid($order->products[$i]['id'])) . "'", "db_link", false);
        }
        if (xtc_db_num_rows($stock_query) > 0) {
          if (empty($t_combis_id) == false) {
            $coo_combis_admin_control = MainFactory::create_object("PropertiesCombisAdminControl");
            $t_use_combis_quantity = $coo_combis_admin_control->get_use_properties_combis_quantity(xtc_get_prid($order->products[$i]['id']));
          } else {
            $t_use_combis_quantity = 0;
          }

          $stock_values = xtc_db_fetch_array($stock_query);
          // do not decrement quantities if products_attributes_filename exists
          if (!$stock_values['products_attributes_filename'] && ((empty($t_combis_id) && STOCK_CHECK == 'true') || (!empty($t_combis_id) && (($t_use_combis_quantity == 0 && STOCK_CHECK == 'true') || $t_use_combis_quantity == 1)))) {
            $stock_left = $stock_values['products_quantity'] - $order->products[$i]['qty'];
          } else {
            $stock_left = $stock_values['products_quantity'];
          }

          xtc_db_query("update " . TABLE_PRODUCTS . " set products_quantity = '" . xtc_db_input($stock_left) . "' where products_id = '" . xtc_db_input(xtc_get_prid($order->products[$i]['id'])) . "'");
          // BOF GM_MOD:
          if (($stock_left < 1) && (STOCK_ALLOW_CHECKOUT == 'false') && GM_SET_OUT_OF_STOCK_PRODUCTS == 'true') {
            xtc_db_query("update " . TABLE_PRODUCTS . " set products_status = '0' where products_id = '" . xtc_db_input(xtc_get_prid($order->products[$i]['id'])) . "'");
          }

          // BOF GM_MOD products_shippingtime:
          set_shipping_status($order->products[$i]['id']);

          // BOF GM_MOD stock_notifier
          if ($stock_left <= STOCK_REORDER_LEVEL) {
            $gm_get_products_name = xtc_db_query("SELECT products_name
                                FROM products_description
                                WHERE products_id = '" . xtc_db_input(xtc_get_prid($order->products[$i]['id'])) . "'
                                    AND language_id = '" . xtc_db_input($_SESSION['languages_id']) . "'");

            $gm_stock_data = mysql_fetch_array($gm_get_products_name);

            $gm_subject = GM_OUT_OF_STOCK_NOTIFY_TEXT . ' ' . $gm_stock_data['products_name'];
            $gm_body = GM_OUT_OF_STOCK_NOTIFY_TEXT . ': ' . (double) $stock_left . "\n\n" . HTTP_SERVER . DIR_WS_CATALOG . 'product_info.php?info=p' .
              xtc_get_prid($order->products[$i]['id']);

            // send mail
            xtc_php_mail(STORE_OWNER_EMAIL_ADDRESS, STORE_NAME, STORE_OWNER_EMAIL_ADDRESS, STORE_NAME, '', STORE_OWNER_EMAIL_ADDRESS, STORE_NAME, '', '', $gm_subject, nl2br(htmlentities($gm_body)), $gm_body);
          }
          // EOF GM_MOD stock_notifier
        }
      }

      // Update products_ordered (for bestsellers list)
      // BOF GM_MOD:
      xtc_db_query("update " . TABLE_PRODUCTS . " set products_ordered = products_ordered + " . xtc_db_input((double) $order->products[$i]['qty']) . " where products_id = '" .
        xtc_db_input(xtc_get_prid($order->products[$i]['id'])) . "'");

      $sql_data_array = array(
        'orders_id' => $insert_id,
        'products_id' => xtc_get_prid($order->products[$i]['id']),
        'products_model' => $order->products[$i]['model'],
        'products_name' => $order->products[$i]['name'],
        'products_shipping_time' => $order->products[$i]['shipping_time'],
        'products_price' => $order->products[$i]['price'],
        'final_price' => $order->products[$i]['final_price'],
        'products_tax' => $order->products[$i]['tax'],
        'products_discount_made' => $order->products[$i]['discount_allowed'],
        'products_quantity' => $order->products[$i]['qty'],
        'allow_tax' => $_SESSION['customers_status']['customers_status_show_price_tax']
      );

      xtc_db_perform(TABLE_ORDERS_PRODUCTS, $sql_data_array);
      $order_products_id = xtc_db_insert_id();

      // BOF GM_MOD GX-Customizer:
//        include (DIR_FS_CATALOG . 'gm/modules/gm_gprint_checkout.php');

      if (!empty($order->products[$i]['quantity_unit_id'])) {
        xtc_db_query("INSERT INTO orders_products_quantity_units
                                SET orders_products_id = '" . xtc_db_input((int) $order_products_id) . "',
                                    quantity_unit_id = '" . xtc_db_input((int) $order->products[$i]['quantity_unit_id']) . "',
                                    unit_name = '" . xtc_db_input($order->products[$i]['unit_name']) . "'");
      }

      # save selected properties_combi in product

      if (is_object($GLOBALS['coo_debugger'])) {
        $GLOBALS['coo_debugger']->log('checkout_process: $order->products[$i][id] ' . $order->products[$i]['id'], 'Properties');
      }
      if (is_object($GLOBALS['coo_debugger'])) {
        $GLOBALS['coo_debugger']->log('checkout_process: extract_combis_id ' . $t_combis_id, 'Properties');
      }

      if (empty($t_combis_id) == false) {
        $coo_properties->add_properties_combi_to_orders_product($t_combis_id, $order_products_id);
        # GM_MOD: ratscheu-fix
        # update properties_combi quantity
        if (($t_use_combis_quantity == 0 && STOCK_CHECK == 'true' && ATTRIBUTES_STOCK_CHECK == 'true') || $t_use_combis_quantity == 2) {
          $t_quantity_change = $order->products[$i]['qty'] * -1;
          $val = $coo_properties->change_combis_quantity($t_combis_id, $t_quantity_change);
        }
        #echo 'c:'.$t_quantity_change.',v:'.$val;
      }

      // Aenderung Specials Quantity Anfang
      $specials_result = xtc_db_query("SELECT products_id, specials_quantity from " . TABLE_SPECIALS . " WHERE products_id = '" . xtc_db_input(xtc_get_prid($order->products[$i]['id'])) . "' ");
      if (xtc_db_num_rows($specials_result)) {
        $spq = xtc_db_fetch_array($specials_result);

        $new_sp_quantity = ($spq['specials_quantity'] - $order->products[$i]['qty']);

        if ($new_sp_quantity >= 1) {
          xtc_db_query("update " . TABLE_SPECIALS . " set specials_quantity = '" . xtc_db_input($new_sp_quantity) . "' where products_id = '" . xtc_db_input(xtc_get_prid($order->products[$i]['id'])) . "' ");
        } elseif (STOCK_CHECK == 'true') { // BOF GM_MOD:
          xtc_db_query("update " . TABLE_SPECIALS . " set status = '0', specials_quantity = '" . xtc_db_input($new_sp_quantity) . "' where products_id = '" .
            xtc_db_input(xtc_get_prid($order->products[$i]['id'])) . "' ");
        }
      }
      // Aenderung Ende

      $order_total_modules->update_credit_account($i); // GV Code ICW ADDED FOR CREDIT CLASS SYSTEM
      //------insert customer choosen option to order--------
      $attributes_exist = '0';
      $products_ordered_attributes = '';
      if (isset($order->products[$i]['attributes'])) {
        $attributes_exist = '1';
        for ($j = 0, $n2 = sizeof($order->products[$i]['attributes']); $j < $n2; $j++) {
          if (DOWNLOAD_ENABLED == 'true') {
            $attributes_query = "select popt.products_options_name,
                                    poval.products_options_values_name,
                                    pa.options_values_price,
                                    pa.price_prefix,
                                    pad.products_attributes_maxdays,
                                    pad.products_attributes_maxcount,
                                    pad.products_attributes_filename
                                from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa
                                left join " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad
                                on pa.products_attributes_id=pad.products_attributes_id
                                where pa.products_id = '" . xtc_db_input($order->products[$i]['id']) . "'
                                    and pa.options_id = '" . xtc_db_input($order->products[$i]['attributes'][$j]['option_id']) . "'
                                    and pa.options_id = popt.products_options_id
                                    and pa.options_values_id = '" . xtc_db_input($order->products[$i]['attributes'][$j]['value_id']) . "'
                                    and pa.options_values_id = poval.products_options_values_id
                                    and popt.language_id = '" . xtc_db_input($_SESSION['languages_id']) . "'
                                    and poval.language_id = '" . xtc_db_input($_SESSION['languages_id']) . "'";
            $attributes = xtc_db_query($attributes_query);
          } else {
            $attributes = xtc_db_query("select popt.products_options_name,
                                    poval.products_options_values_name,
                                    pa.options_values_price,
                                    pa.price_prefix
                                from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa
                                where pa.products_id = '" . xtc_db_input($order->products[$i]['id']) . "'
                                    and pa.options_id = '" . xtc_db_input($order->products[$i]['attributes'][$j]['option_id']) . "'
                                    and pa.options_id = popt.products_options_id
                                    and pa.options_values_id = '" . xtc_db_input($order->products[$i]['attributes'][$j]['value_id']) . "'
                                    and pa.options_values_id = poval.products_options_values_id
                                    and popt.language_id = '" . xtc_db_input($_SESSION['languages_id']) . "'
                                    and poval.language_id = '" . xtc_db_input($_SESSION['languages_id']) . "'");
          }
          // update attribute stock
          xtc_db_query("UPDATE " . TABLE_PRODUCTS_ATTRIBUTES . " set attributes_stock=attributes_stock - '" . xtc_db_input($order->products[$i]['qty']) . "'
                                where products_id='" . xtc_db_input($order->products[$i]['id']) . "'
                                    and options_values_id='" . xtc_db_input($order->products[$i]['attributes'][$j]['value_id']) . "'
                                    and options_id='" . xtc_db_input($order->products[$i]['attributes'][$j]['option_id']) . "'");

          $attributes_values = xtc_db_fetch_array($attributes);

          $sql_data_array = array(
            'orders_id' => $insert_id,
            'orders_products_id' => $order_products_id,
            'products_options' => $attributes_values['products_options_name'],
            'products_options_values' => $attributes_values['products_options_values_name'],
            'options_values_price' => $attributes_values['options_values_price'],
            'price_prefix' => $attributes_values['price_prefix']
          );
          xtc_db_perform(TABLE_ORDERS_PRODUCTS_ATTRIBUTES, $sql_data_array);

          if ((DOWNLOAD_ENABLED == 'true') && isset($attributes_values['products_attributes_filename']) && xtc_not_null($attributes_values['products_attributes_filename'])) {
            $sql_data_array = array(
              'orders_id' => $insert_id,
              'orders_products_id' => $order_products_id,
              'orders_products_filename' => $attributes_values['products_attributes_filename'],
              'download_maxdays' => $attributes_values['products_attributes_maxdays'],
              'download_count' => $attributes_values['products_attributes_maxcount']
            );
            xtc_db_perform(TABLE_ORDERS_PRODUCTS_DOWNLOAD, $sql_data_array);
          }

          // BOF GM_MOD attributes stock_notifier
          // Avenger
          if (ATTRIBUTE_STOCK_CHECK == 'true') {
            $gm_get_attributes_stock = xtc_db_query("SELECT
                                    pd.products_name,
                                    pa.attributes_stock,
                                    po.products_options_name,
                                    pov.products_options_values_name
                                FROM
                                    products_description pd,
                                    products_attributes pa,
                                    products_options po,
                                    products_options_values pov
                                WHERE pa.products_id = '" . xtc_db_input($order->products[$i]['id']) . "'
                                    AND pa.options_values_id = '" . xtc_db_input($order->products[$i]['attributes'][$j]['value_id']) . "'
                                    AND pa.options_id = '" . xtc_db_input($order->products[$i]['attributes'][$j]['option_id']) . "'
                                    AND po.products_options_id = '" . xtc_db_input($order->products[$i]['attributes'][$j]['option_id']) . "'
                                    AND po.language_id = '" . xtc_db_input($_SESSION['languages_id']) . "'
                                    AND pov.products_options_values_id = '" . xtc_db_input($order->products[$i]['attributes'][$j]['value_id']) . "'
                                    AND pov.language_id = '" . xtc_db_input($_SESSION['languages_id']) . "'
                                    AND pd.products_id = '" . xtc_db_input($order->products[$i]['id']) . "'
                                    AND pd.language_id = '" . xtc_db_input($_SESSION['languages_id']) . "'");
            if (xtc_db_num_rows($gm_get_attributes_stock) == 1) {
              $gm_attributes_stock_data = xtc_db_fetch_array($gm_get_attributes_stock);

              if ($gm_attributes_stock_data['attributes_stock'] <= STOCK_REORDER_LEVEL) {
                $gm_subject = GM_OUT_OF_STOCK_NOTIFY_TEXT . ' ' . $gm_attributes_stock_data['products_name'] . ' - ' . $gm_attributes_stock_data['products_options_name'] . ': ' .
                  $gm_attributes_stock_data['products_options_values_name'];
                $gm_body = GM_OUT_OF_STOCK_NOTIFY_TEXT . ': ' . (double) $gm_attributes_stock_data['attributes_stock'] . ' (' . $gm_attributes_stock_data['products_name'] .
                  ' - ' . $gm_attributes_stock_data['products_options_name'] . ': ' . $gm_attributes_stock_data['products_options_values_name'] . ")\n\n" .
                  HTTP_SERVER . DIR_WS_CATALOG . 'product_info.php?info=p' . xtc_get_prid($order->products[$i]['id']);

                xtc_php_mail(STORE_OWNER_EMAIL_ADDRESS, STORE_NAME, STORE_OWNER_EMAIL_ADDRESS, STORE_NAME, '', STORE_OWNER_EMAIL_ADDRESS, STORE_NAME, '', '', $gm_subject, nl2br(htmlentities($gm_body)), $gm_body);
              }
            }
          }
          // Avenger
          // EOF GM_MOD attributes stock_notifier
        }
      }
      //------insert customer choosen option eof ----
      $total_weight += ($order->products[$i]['qty'] * $order->products[$i]['weight']);
      $total_tax += xtc_calculate_tax($total_products_price, $products_tax) * $order->products[$i]['qty'];
      $total_cost += $total_products_price;
    }

    if (isset($_SESSION['tracking']['refID'])) {
      xtc_db_query("update " . TABLE_ORDERS . " set refferers_id = '" . xtc_db_input($_SESSION['tracking']['refID']) . "' where orders_id = '" . xtc_db_input($insert_id) . "'");

      // check if late or direct sale
      $customers_logon_query = "SELECT customers_info_number_of_logons FROM " . TABLE_CUSTOMERS_INFO . " WHERE customers_info_id  = '" . xtc_db_input($_SESSION['customer_id']) . "'";
      $customers_logon_query = xtc_db_query($customers_logon_query);
      $customers_logon = xtc_db_fetch_array($customers_logon_query);
      if ($customers_logon['customers_info_number_of_logons'] == 0) {
        // direct sale
        xtc_db_query("update " . TABLE_ORDERS . " set conversion_type = '1' where orders_id = '" . xtc_db_input($insert_id) . "'");
      } else {
        // late sale
        xtc_db_query("update " . TABLE_ORDERS . " set conversion_type = '2' where orders_id = '" . xtc_db_input($insert_id) . "'");
      }
    } else {
      $customers_query = xtc_db_query("SELECT refferers_id as ref FROM " . TABLE_CUSTOMERS . " WHERE customers_id='" . xtc_db_input($_SESSION['customer_id']) . "'");
      $customers_data = xtc_db_fetch_array($customers_query);
      if (xtc_db_num_rows($customers_query)) {
        xtc_db_query("update " . TABLE_ORDERS . " set refferers_id = '" . xtc_db_input($customers_data['ref']) . "' where orders_id = '" . xtc_db_input($insert_id) . "'");
        // check if late or direct sale
        $customers_logon_query = "SELECT customers_info_number_of_logons FROM " . TABLE_CUSTOMERS_INFO . " WHERE customers_info_id  = '" . xtc_db_input($_SESSION['customer_id']) . "'";
        $customers_logon_query = xtc_db_query($customers_logon_query);
        $customers_logon = xtc_db_fetch_array($customers_logon_query);

        if ($customers_logon['customers_info_number_of_logons'] == 0) {
          // direct sale
          xtc_db_query("update " . TABLE_ORDERS . " set conversion_type = '1' where orders_id = '" . xtc_db_input($insert_id) . "'");
        } else {
          // late sale
          xtc_db_query("update " . TABLE_ORDERS . " set conversion_type = '2' where orders_id = '" . xtc_db_input($insert_id) . "'");
        }
      }
    }

    $_SESSION[$this->_gc_cartID] = $_SESSION['cartID'] . '-' . $insert_id;


    $this->payment_action();

    return false;
  }

// end before_process()

  /**
   * Functions to execute after process the payment
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return boolean
   */
  function after_process() {
    return false;
  }

//end after_process()

  /**
   * Get error message to display
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return array
   */
  function get_error() {
    global $_GET;
    $error = array(
      'title' => $this->title,
      'error' => utf8_decode(stripslashes(urldecode($_GET['error'])))
    );

    return $error;
  }

// end get_error()

  /**
   * Check if module is installed (Administration Tool)_
   * TABLES: configuration
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return int
   */
  function check() {
    $gx_version = $this->getGxVersion();

    if (!isset($this->_check)) {
      if (version_compare($gx_version, COMPARE_SHOP_VERSION, '>=')) {
        $check_query = xtc_db_query("select `value` from " . TABLE_CONFIGURATION . " where `key` = 'configuration/MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_STATUS'");
      } else {
        $check_query = xtc_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_STATUS'");
      }

      $this->_check = xtc_db_num_rows($check_query);
    }

    return $this->_check;
  }

// end check()

  /**
   * Install the module (Administration Tool)_
   * TABLES: configuration
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return void
   */
  function install() {
    $gx_version = $this->getGxVersion();

    // Update Configuration field Length 255 is often too short
    //xtc_db_query('ALTER TABLE ' . TABLE_CONFIGURATION . ' CHANGE set_function set_function VARCHAR( 510 ) NOT NULL');

    if (version_compare($gx_version, COMPARE_SHOP_VERSION, '>=')) {
      // Update Configuration Key Length 64 is often too short
      xtc_db_query('ALTER TABLE ' . TABLE_CONFIGURATION . ' CHANGE `key` `key` VARCHAR( 255 ) NOT NULL');

      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, legacy_group_id, sort_order, `type`, last_modified)" .
        "  values ('configuration/MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_STATUS', 'False', '6', '0', 'switcher', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, legacy_group_id, sort_order, last_modified)" .
        "  values ('configuration/MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_SORT_ORDER', '0', '6', '0', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, legacy_group_id, sort_order, last_modified)" .
        "  values ('configuration/MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_MERCHANTID', '', '6', '10', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, legacy_group_id, sort_order, last_modified)" .
        "  values ('configuration/MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_PROJECTID', '', '6', '10', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, legacy_group_id, sort_order, last_modified)" .
        "  values ('configuration/MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_PASSWORD', '', '6', '10', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, legacy_group_id, sort_order, `type`, last_modified)" .
        "  values ('configuration/MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_ZONE', '0', '6', '20', 'geo-zone', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, legacy_group_id, sort_order, last_modified)" .
        "  values ('configuration/MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_ALLOWED', '', '6', '30', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, legacy_group_id, sort_order, `type`, last_modified)" .
        "  values ('configuration/MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_ORDER_STATUS_ID_ERROR', '330', '6', '40', 'order-status', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, legacy_group_id, sort_order, `type`, last_modified)" .
        "  values ('configuration/MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_ORDER_STATUS_ID_OK', '2', '6', '40', 'order-status', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, legacy_group_id, sort_order, `type`, last_modified)" .
        "  values ('configuration/MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_ORDER_STATUS_ID_TEMP', '1', '6', '40',  'order-status', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, legacy_group_id, sort_order, `type`, last_modified)" .
        "  values ('configuration/MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_DELETE_ORDER', 'true', '6', '0', 'switcher', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, legacy_group_id, sort_order, last_modified)" .
        "  values ('configuration/MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_PURPOSE', 'Best. {ORDERID}, {SHOPNAME}', '6', '40', now())");

      if ($this->code == 'gc_creditcard') {
        xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, legacy_group_id, sort_order, `type`, last_modified)" .
          "  values ('configuration/MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_VISA_MASTERCARD', 'true', '6', '0', 'switcher', now())");
        xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, legacy_group_id, sort_order, `type`, last_modified)" .
          "  values ('configuration/MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_AMEX', 'true', '6', '0', 'switcher', now())");
        xtc_db_query("insert into " . TABLE_CONFIGURATION . " (`key`, `value`, legacy_group_id, sort_order, `type`, last_modified)" .
          "  values ('configuration/MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_JCB', 'true', '6', '0', 'switcher', now())");
      }
    } else {
      xtc_db_query('ALTER TABLE ' . TABLE_CONFIGURATION . ' CHANGE configuration_key configuration_key VARCHAR( 255 ) NOT NULL');

      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added)" .
        "  values ('MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_STATUS', 'False', '6', '0', 'xtc_cfg_select_option(array(\'True\', \'False\'), ', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added)" .
        "  values ('MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_SORT_ORDER', '0', '6', '0', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added)" .
        "  values ('MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_MERCHANTID', '', '6', '10', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added)" .
        "  values ('MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_PROJECTID', '', '6', '10', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added)" .
        "  values ('MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_PASSWORD', '', '6', '10', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, use_function, set_function, date_added)" .
        "  values ('MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_ZONE', '0', '6', '20', 'xtc_get_zone_class_title', 'xtc_cfg_pull_down_zone_classes(', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added)" .
        "  values ('MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_ALLOWED', '', '6', '30', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, use_function, date_added)" .
        "  values ('MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_ORDER_STATUS_ID_ERROR', '99', '6', '40', 'xtc_cfg_pull_down_order_statuses(', 'xtc_get_order_status_name', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, use_function, date_added)" .
        "  values ('MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_ORDER_STATUS_ID_OK', '2', '6', '40', 'xtc_cfg_pull_down_order_statuses(', 'xtc_get_order_status_name', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, use_function, date_added)" .
        "  values ('MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_ORDER_STATUS_ID_TEMP', '1', '6', '40', 'xtc_cfg_pull_down_order_statuses(', 'xtc_get_order_status_name', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added)" .
        "  values ('MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_DELETE_ORDER', 'True', '6', '0', 'xtc_cfg_select_option(array(\'True\', \'False\'), ', now())");
      xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, date_added)" .
        "  values ('MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_PURPOSE', 'Best. {ORDERID}, {SHOPNAME}', '6', '40', now())");

      if ($this->code == 'gc_creditcard') {
        xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added)" .
          "  values ('MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_VISA_MASTERCARD', 'True', '6', '0', 'xtc_cfg_select_option(array(\'True\', \'False\'), ', now())");
        xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added)" .
          "  values ('MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_AMEX', 'True', '6', '0', 'xtc_cfg_select_option(array(\'True\', \'False\'), ', now())");
        xtc_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_key, configuration_value, configuration_group_id, sort_order, set_function, date_added)" .
          "  values ('MODULE_PAYMENT_" . xtc_db_input(strtoupper($this->code)) . "_JCB', 'True', '6', '0', 'xtc_cfg_select_option(array(\'True\', \'False\'), ', now())");
      }
    }

    //create table to register orders and status.
    xtc_db_query("CREATE TABLE IF NOT EXISTS gc_transactions(
                  tx_id int(11) NOT NULL AUTO_INCREMENT,
                  order_id int(11) NOT NULL,
                  rc int(11) NULL,
                  rc_msg varchar(255) NULL,
                  init_start int(11) NULL,
                  init_end int(11) NULL,
                  time_finished int(11) NULL,
                  reference varchar(255) NULL,
                  backend_tx_id varchar(255) NULL,
                  result_payment int(11) NULL,
                  result_payment_msg varchar(255) NULL,
                  tx_status int(1) NOT NULL,
                  payment_code varchar(100) NULL,
                  comment text NULL,
                  PRIMARY KEY (tx_id)
                  )");

    $columns_query = xtc_db_query("SHOW COLUMNS FROM `gc_transactions` LIKE '%payment_code%'");
    if (!xtc_db_num_rows($columns_query)) {
      xtc_db_query("ALTER TABLE `gc_transactions` ADD `payment_code` varchar(100) NULL");
    }

    $columns_query = xtc_db_query("SHOW COLUMNS FROM `gc_transactions` LIKE '%comment%'");
    if (!xtc_db_num_rows($columns_query)) {
      xtc_db_query("ALTER TABLE `gc_transactions` ADD `comment` text NULL");
    }
  }

// end install()

  /**
   * Remove the module (Administration Tool)_
   * TABLES: configuration
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return void
   */
  function remove() {
    $strKeys = implode("', '", $this->keys());
    $gx_version = $this->getGxVersion();

    if (version_compare($gx_version, COMPARE_SHOP_VERSION, '>=')) {
      xtc_db_query("delete from " . TABLE_CONFIGURATION . " where `key` in ('" . $strKeys . "')");
    } else {
      xtc_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . $strKeys . "')");
    }
  }

// end remove()

  /**
   * Retrieve the modules configuration keys (Administration Tool)_
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return array
   */
  function keys() {
    $keys = array();
    $gx_version = $this->getGxVersion();

    if (version_compare($gx_version, COMPARE_SHOP_VERSION, '>=')) {
      $prefix = "configuration/";
    } else {
      $prefix = "";
    }

    $keys[] = $prefix."MODULE_PAYMENT_" . strtoupper($this->code) . "_STATUS";
    $keys[] = $prefix."MODULE_PAYMENT_" . strtoupper($this->code) . "_SORT_ORDER";
    $keys[] = $prefix."MODULE_PAYMENT_" . strtoupper($this->code) . "_MERCHANTID";
    $keys[] = $prefix."MODULE_PAYMENT_" . strtoupper($this->code) . "_PROJECTID";
    $keys[] = $prefix."MODULE_PAYMENT_" . strtoupper($this->code) . "_PASSWORD";
    $keys[] = $prefix."MODULE_PAYMENT_" . strtoupper($this->code) . "_ZONE";
    $keys[] = $prefix."MODULE_PAYMENT_" . strtoupper($this->code) . "_ALLOWED";
    $keys[] = $prefix."MODULE_PAYMENT_" . strtoupper($this->code) . "_DELETE_ORDER";
    $keys[] = $prefix."MODULE_PAYMENT_" . strtoupper($this->code) . "_ORDER_STATUS_ID_ERROR";
    $keys[] = $prefix."MODULE_PAYMENT_" . strtoupper($this->code) . "_ORDER_STATUS_ID_OK";
    $keys[] = $prefix."MODULE_PAYMENT_" . strtoupper($this->code) . "_ORDER_STATUS_ID_TEMP";
    $keys[] = $prefix."MODULE_PAYMENT_" . strtoupper($this->code) . "_PURPOSE";

    if ($this->code == 'gc_creditcard') {
      $keys[] = $prefix."MODULE_PAYMENT_" . strtoupper($this->code) . "_VISA_MASTERCARD";
      $keys[] = $prefix."MODULE_PAYMENT_" . strtoupper($this->code) . "_AMEX";
      $keys[] = $prefix."MODULE_PAYMENT_" . strtoupper($this->code) . "_JCB";
    }

    return $keys;
  }

// end keys()

  /**
   * Get Source parameter.
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return String
   */
  public function getGcSource() {
    include(DIR_FS_CATALOG . 'release_info.php');

    return "Gambio " . $gx_version . ";Gambio Plugin " . __GIROCONNECT_PLUGIN_VERSION__;
  }

  /**
   * Get Source parameter.
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return String
   */
  public function getGxVersion() {
    include(DIR_FS_CATALOG . 'release_info.php');

    return $gx_version;
  }

// End getGcSource()

  /**
   * Get Source parameter.
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return String
   */
  public function getGcShopVersion() {
    include(DIR_FS_CATALOG . 'release_info.php');

    return str_replace("v", "", $gx_version);
  }

// End getGcSource()

  /**
   * Get the payment purpose.
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2014, GiroSolution AG
   * @return int
   */
  public function getPurpose($purpose, $order, $order_id) {
    $strPurpose = $purpose;
    $strLastName = "";
    $strFirstName = "";
    $strShopName = "";

    $iCustomerNr = $_SESSION['customer_id'];
    $strLastName = $order->customer['lastname'];
    $strFirstName = $order->customer['firstname'];
    $strName = $order->customer['firstname'] . ", " . $order->customer['lastname'];

    $strShopName = STORE_NAME;

    if (empty($strPurpose)) {
      $strPurpose = "{ORDERID}, {SHOPNAME}";
    }

    $strPurpose = str_replace("{ORDERID}", $order_id, $strPurpose);
    $strPurpose = str_replace("{CUSTOMERID}", $iCustomerNr, $strPurpose);
    $strPurpose = str_replace("{SHOPNAME}", $strShopName, $strPurpose);
    $strPurpose = str_replace("{CUSTOMERNAME}", $strName, $strPurpose);
    $strPurpose = str_replace("{CUSTOMERFIRSTNAME}", $strFirstName, $strPurpose);
    $strPurpose = str_replace("{CUSTOMERLASTNAME}", $strLastName, $strPurpose);

    if (empty($strPurpose)) {
      if (!empty($strFirstName) || !empty($strLastName)) {
        $strPurpose = "Kunde: " . $strFirstName . " " . $strLastName;
      } else if (!empty($strShopName)) {
        $strPurpose = "Bestellung: " . $strShopName;
      } else {
        $strPurpose = "Bestellung: Shopware";
      }
    }

    return utf8_encode(trim(substr($strPurpose, 0, 27)));
  }

  /**
   * Get shipping information for paydirekt.
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2016, GiroSolution AG
   * @return int
   */
  public function getShippingData($order) {

    $aReturn = array();
    try {

      if ($order->delivery) {
        $aReturn["shippingAddresseFirstName"] = $order->delivery["firstname"];
        $aReturn["shippingAddresseLastName"] = $order->delivery["lastname"];
        $aReturn["shippingCompany"] = $order->delivery["company"];
        $aReturn["shippingAdditionalAddressInformation"] = "";
        $aReturn["shippingStreet"] = $order->delivery["street_address"];
        $aReturn["shippingZipCode"] = $order->delivery["postcode"];
        $aReturn["shippingCity"] = $order->delivery["city"];
        $aReturn["shippingCountryIso"] = $order->delivery["country"]["iso_code_2"];
      } else if ($order->billing) {
        $aReturn["shippingAddresseFirstName"] = $order->billing["firstname"];
        $aReturn["shippingAddresseLastName"] = $order->billing["lastname"];
        $aReturn["shippingCompany"] = $order->billing["company"];
        $aReturn["shippingAdditionalAddressInformation"] = "";
        $aReturn["shippingStreet"] = $order->billing["street_address"];
        $aReturn["shippingZipCode"] = $order->billing["postcode"];
        $aReturn["shippingCity"] = $order->billing["city"];
        $aReturn["shippingCountryIso"] = $order->billing["country"]["iso_code_2"];
      }
      $aReturn["customerMail"] = $order->customer['email_address'];
    } catch (Exception $exception) {
      throw new Exception("Exception in getShippingData(): " . $exception->getMessage());
    }

    return $aReturn;
  }

}
MainFactory::load_origin_class('class.giroconnect.php');

// end class giroconnect_main
